#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#include "fnd.h"


#define FND_OUT	PORTA
#define FND_DDR	DDRA
#define DOT_OUT	PORTE
#define DOT_DDR	DDRE
#define DOT		0x80


volatile unsigned char fnd_buf[4], dot_buf[4], digit;
volatile char fnd_flag, dot_flag;


ISR(TIMER2_OVF_vect)
{
	TCNT2 = 256 - 125;

	FND_OUT = 0x00;
	DOT_OUT |= 0x80;

	if( fnd_flag ) {
		FND_OUT = fnd_buf[digit];
		FND_OUT |= 0x10 << digit;
	}

	if( dot_flag ) {
		if( dot_buf[digit] )	DOT_OUT &= ~DOT;
	}

	digit = ++digit % 4;
}

void timer2_init(void)
{
	TCCR2 = 0x04;
	TCNT2 = 256 - 125;
	TIMSK |= 0x40;
}

void fnd_init(void)
{
	FND_DDR = 0xFF;
	DOT_DDR |= 0x80;

	for( int i = 0; i < 4; i++ ) {
		fnd_buf[i] = 0x0F;
		dot_buf[i] = 0;
	}
	fnd_flag = 0;
	dot_flag = 0;
	digit = 0;

	timer2_init();
}
